<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNominalCodeBalance ArrayType
 * @subpackage Arrays
 */
class ArrayOfNominalCodeBalance extends AbstractStructArrayBase
{
    /**
     * The NominalCodeBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NominalCodeBalance[]
     */
    public $NominalCodeBalance;
    /**
     * Constructor method for ArrayOfNominalCodeBalance
     * @uses ArrayOfNominalCodeBalance::setNominalCodeBalance()
     * @param \StructType\NominalCodeBalance[] $nominalCodeBalance
     */
    public function __construct(array $nominalCodeBalance = array())
    {
        $this
            ->setNominalCodeBalance($nominalCodeBalance);
    }
    /**
     * Get NominalCodeBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NominalCodeBalance[]|null
     */
    public function getNominalCodeBalance()
    {
        return isset($this->NominalCodeBalance) ? $this->NominalCodeBalance : null;
    }
    /**
     * This method is responsible for validating the values passed to the setNominalCodeBalance method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNominalCodeBalance method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNominalCodeBalanceForArrayConstraintsFromSetNominalCodeBalance(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNominalCodeBalanceNominalCodeBalanceItem) {
            // validation for constraint: itemType
            if (!$arrayOfNominalCodeBalanceNominalCodeBalanceItem instanceof \StructType\NominalCodeBalance) {
                $invalidValues[] = is_object($arrayOfNominalCodeBalanceNominalCodeBalanceItem) ? get_class($arrayOfNominalCodeBalanceNominalCodeBalanceItem) : sprintf('%s(%s)', gettype($arrayOfNominalCodeBalanceNominalCodeBalanceItem), var_export($arrayOfNominalCodeBalanceNominalCodeBalanceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NominalCodeBalance property can only contain items of type \StructType\NominalCodeBalance, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NominalCodeBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\NominalCodeBalance[] $nominalCodeBalance
     * @return \ArrayType\ArrayOfNominalCodeBalance
     */
    public function setNominalCodeBalance(array $nominalCodeBalance = array())
    {
        // validation for constraint: array
        if ('' !== ($nominalCodeBalanceArrayErrorMessage = self::validateNominalCodeBalanceForArrayConstraintsFromSetNominalCodeBalance($nominalCodeBalance))) {
            throw new \InvalidArgumentException($nominalCodeBalanceArrayErrorMessage, __LINE__);
        }
        if (is_null($nominalCodeBalance) || (is_array($nominalCodeBalance) && empty($nominalCodeBalance))) {
            unset($this->NominalCodeBalance);
        } else {
            $this->NominalCodeBalance = $nominalCodeBalance;
        }
        return $this;
    }
    /**
     * Add item to NominalCodeBalance value
     * @throws \InvalidArgumentException
     * @param \StructType\NominalCodeBalance $item
     * @return \ArrayType\ArrayOfNominalCodeBalance
     */
    public function addToNominalCodeBalance(\StructType\NominalCodeBalance $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NominalCodeBalance) {
            throw new \InvalidArgumentException(sprintf('The NominalCodeBalance property can only contain items of type \StructType\NominalCodeBalance, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NominalCodeBalance[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\NominalCodeBalance|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\NominalCodeBalance|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\NominalCodeBalance|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\NominalCodeBalance|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\NominalCodeBalance|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NominalCodeBalance
     */
    public function getAttributeName()
    {
        return 'NominalCodeBalance';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNominalCodeBalance
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
