<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetKPIs StructType
 * @subpackage Structs
 */
class GetKPIs extends AbstractStructBase
{
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $StartDate;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $EndDate;
    /**
     * The ExcludeVAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ExcludeVAT;
    /**
     * The ExcludeSameDayPays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ExcludeSameDayPays;
    /**
     * The UserName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UserName;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * Constructor method for GetKPIs
     * @uses GetKPIs::setStartDate()
     * @uses GetKPIs::setEndDate()
     * @uses GetKPIs::setExcludeVAT()
     * @uses GetKPIs::setExcludeSameDayPays()
     * @uses GetKPIs::setUserName()
     * @uses GetKPIs::setPassword()
     * @param string $startDate
     * @param string $endDate
     * @param int $excludeVAT
     * @param int $excludeSameDayPays
     * @param string $userName
     * @param string $password
     */
    public function __construct($startDate = null, $endDate = null, $excludeVAT = null, $excludeSameDayPays = null, $userName = null, $password = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setExcludeVAT($excludeVAT)
            ->setExcludeSameDayPays($excludeSameDayPays)
            ->setUserName($userName)
            ->setPassword($password);
    }
    /**
     * Get StartDate value
     * @return string
     */
    public function getStartDate()
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \StructType\GetKPIs
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        return $this;
    }
    /**
     * Get EndDate value
     * @return string
     */
    public function getEndDate()
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \StructType\GetKPIs
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        return $this;
    }
    /**
     * Get ExcludeVAT value
     * @return int
     */
    public function getExcludeVAT()
    {
        return $this->ExcludeVAT;
    }
    /**
     * Set ExcludeVAT value
     * @param int $excludeVAT
     * @return \StructType\GetKPIs
     */
    public function setExcludeVAT($excludeVAT = null)
    {
        // validation for constraint: int
        if (!is_null($excludeVAT) && !(is_int($excludeVAT) || ctype_digit($excludeVAT))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($excludeVAT, true), gettype($excludeVAT)), __LINE__);
        }
        $this->ExcludeVAT = $excludeVAT;
        return $this;
    }
    /**
     * Get ExcludeSameDayPays value
     * @return int
     */
    public function getExcludeSameDayPays()
    {
        return $this->ExcludeSameDayPays;
    }
    /**
     * Set ExcludeSameDayPays value
     * @param int $excludeSameDayPays
     * @return \StructType\GetKPIs
     */
    public function setExcludeSameDayPays($excludeSameDayPays = null)
    {
        // validation for constraint: int
        if (!is_null($excludeSameDayPays) && !(is_int($excludeSameDayPays) || ctype_digit($excludeSameDayPays))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($excludeSameDayPays, true), gettype($excludeSameDayPays)), __LINE__);
        }
        $this->ExcludeSameDayPays = $excludeSameDayPays;
        return $this;
    }
    /**
     * Get UserName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->UserName;
    }
    /**
     * Set UserName value
     * @param string $userName
     * @return \StructType\GetKPIs
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->UserName = $userName;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GetKPIs
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetKPIs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
