<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Invoice_TypeDefined StructType
 * @subpackage Structs
 */
class Invoice_TypeDefined extends AbstractStructBase
{
    /**
     * The InvoiceDBID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $InvoiceDBID;
    /**
     * The InvoiceNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $InvoiceNumber;
    /**
     * The InvoiceDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InvoiceDate;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $DueDate;
    /**
     * The CustomerID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CustomerID;
    /**
     * The Paid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Paid;
    /**
     * The SuppressTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SuppressTotal;
    /**
     * The ProjectID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ProjectID;
    /**
     * The ExchangeRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $ExchangeRate;
    /**
     * The NetAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $NetAmount;
    /**
     * The VATAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $VATAmount;
    /**
     * The AmountPaid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AmountPaid;
    /**
     * The Customer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Customer;
    /**
     * The CustomerReference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerReference;
    /**
     * The EstimateCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EstimateCategory;
    /**
     * The CurrencyCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CurrencyCode;
    /**
     * The ReadableString
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReadableString;
    /**
     * The Lines
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInvoiceLine
     */
    public $Lines;
    /**
     * The CustomerName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerName;
    /**
     * Constructor method for Invoice_TypeDefined
     * @uses Invoice_TypeDefined::setInvoiceDBID()
     * @uses Invoice_TypeDefined::setInvoiceNumber()
     * @uses Invoice_TypeDefined::setInvoiceDate()
     * @uses Invoice_TypeDefined::setDueDate()
     * @uses Invoice_TypeDefined::setCustomerID()
     * @uses Invoice_TypeDefined::setPaid()
     * @uses Invoice_TypeDefined::setSuppressTotal()
     * @uses Invoice_TypeDefined::setProjectID()
     * @uses Invoice_TypeDefined::setExchangeRate()
     * @uses Invoice_TypeDefined::setNetAmount()
     * @uses Invoice_TypeDefined::setVATAmount()
     * @uses Invoice_TypeDefined::setAmountPaid()
     * @uses Invoice_TypeDefined::setCustomer()
     * @uses Invoice_TypeDefined::setCustomerReference()
     * @uses Invoice_TypeDefined::setEstimateCategory()
     * @uses Invoice_TypeDefined::setCurrencyCode()
     * @uses Invoice_TypeDefined::setReadableString()
     * @uses Invoice_TypeDefined::setLines()
     * @uses Invoice_TypeDefined::setCustomerName()
     * @param int $invoiceDBID
     * @param int $invoiceNumber
     * @param string $invoiceDate
     * @param string $dueDate
     * @param int $customerID
     * @param int $paid
     * @param int $suppressTotal
     * @param int $projectID
     * @param float $exchangeRate
     * @param float $netAmount
     * @param float $vATAmount
     * @param float $amountPaid
     * @param string $customer
     * @param string $customerReference
     * @param string $estimateCategory
     * @param string $currencyCode
     * @param string $readableString
     * @param \ArrayType\ArrayOfInvoiceLine $lines
     * @param string $customerName
     */
    public function __construct($invoiceDBID = null, $invoiceNumber = null, $invoiceDate = null, $dueDate = null, $customerID = null, $paid = null, $suppressTotal = null, $projectID = null, $exchangeRate = null, $netAmount = null, $vATAmount = null, $amountPaid = null, $customer = null, $customerReference = null, $estimateCategory = null, $currencyCode = null, $readableString = null, \ArrayType\ArrayOfInvoiceLine $lines = null, $customerName = null)
    {
        $this
            ->setInvoiceDBID($invoiceDBID)
            ->setInvoiceNumber($invoiceNumber)
            ->setInvoiceDate($invoiceDate)
            ->setDueDate($dueDate)
            ->setCustomerID($customerID)
            ->setPaid($paid)
            ->setSuppressTotal($suppressTotal)
            ->setProjectID($projectID)
            ->setExchangeRate($exchangeRate)
            ->setNetAmount($netAmount)
            ->setVATAmount($vATAmount)
            ->setAmountPaid($amountPaid)
            ->setCustomer($customer)
            ->setCustomerReference($customerReference)
            ->setEstimateCategory($estimateCategory)
            ->setCurrencyCode($currencyCode)
            ->setReadableString($readableString)
            ->setLines($lines)
            ->setCustomerName($customerName);
    }
    /**
     * Get InvoiceDBID value
     * @return int
     */
    public function getInvoiceDBID()
    {
        return $this->InvoiceDBID;
    }
    /**
     * Set InvoiceDBID value
     * @param int $invoiceDBID
     * @return \StructType\Invoice_TypeDefined
     */
    public function setInvoiceDBID($invoiceDBID = null)
    {
        // validation for constraint: int
        if (!is_null($invoiceDBID) && !(is_int($invoiceDBID) || ctype_digit($invoiceDBID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($invoiceDBID, true), gettype($invoiceDBID)), __LINE__);
        }
        $this->InvoiceDBID = $invoiceDBID;
        return $this;
    }
    /**
     * Get InvoiceNumber value
     * @return int
     */
    public function getInvoiceNumber()
    {
        return $this->InvoiceNumber;
    }
    /**
     * Set InvoiceNumber value
     * @param int $invoiceNumber
     * @return \StructType\Invoice_TypeDefined
     */
    public function setInvoiceNumber($invoiceNumber = null)
    {
        // validation for constraint: int
        if (!is_null($invoiceNumber) && !(is_int($invoiceNumber) || ctype_digit($invoiceNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($invoiceNumber, true), gettype($invoiceNumber)), __LINE__);
        }
        $this->InvoiceNumber = $invoiceNumber;
        return $this;
    }
    /**
     * Get InvoiceDate value
     * @return string
     */
    public function getInvoiceDate()
    {
        return $this->InvoiceDate;
    }
    /**
     * Set InvoiceDate value
     * @param string $invoiceDate
     * @return \StructType\Invoice_TypeDefined
     */
    public function setInvoiceDate($invoiceDate = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceDate) && !is_string($invoiceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceDate, true), gettype($invoiceDate)), __LINE__);
        }
        $this->InvoiceDate = $invoiceDate;
        return $this;
    }
    /**
     * Get DueDate value
     * @return string
     */
    public function getDueDate()
    {
        return $this->DueDate;
    }
    /**
     * Set DueDate value
     * @param string $dueDate
     * @return \StructType\Invoice_TypeDefined
     */
    public function setDueDate($dueDate = null)
    {
        // validation for constraint: string
        if (!is_null($dueDate) && !is_string($dueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dueDate, true), gettype($dueDate)), __LINE__);
        }
        $this->DueDate = $dueDate;
        return $this;
    }
    /**
     * Get CustomerID value
     * @return int
     */
    public function getCustomerID()
    {
        return $this->CustomerID;
    }
    /**
     * Set CustomerID value
     * @param int $customerID
     * @return \StructType\Invoice_TypeDefined
     */
    public function setCustomerID($customerID = null)
    {
        // validation for constraint: int
        if (!is_null($customerID) && !(is_int($customerID) || ctype_digit($customerID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerID, true), gettype($customerID)), __LINE__);
        }
        $this->CustomerID = $customerID;
        return $this;
    }
    /**
     * Get Paid value
     * @return int
     */
    public function getPaid()
    {
        return $this->Paid;
    }
    /**
     * Set Paid value
     * @param int $paid
     * @return \StructType\Invoice_TypeDefined
     */
    public function setPaid($paid = null)
    {
        // validation for constraint: int
        if (!is_null($paid) && !(is_int($paid) || ctype_digit($paid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($paid, true), gettype($paid)), __LINE__);
        }
        $this->Paid = $paid;
        return $this;
    }
    /**
     * Get SuppressTotal value
     * @return int
     */
    public function getSuppressTotal()
    {
        return $this->SuppressTotal;
    }
    /**
     * Set SuppressTotal value
     * @param int $suppressTotal
     * @return \StructType\Invoice_TypeDefined
     */
    public function setSuppressTotal($suppressTotal = null)
    {
        // validation for constraint: int
        if (!is_null($suppressTotal) && !(is_int($suppressTotal) || ctype_digit($suppressTotal))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($suppressTotal, true), gettype($suppressTotal)), __LINE__);
        }
        $this->SuppressTotal = $suppressTotal;
        return $this;
    }
    /**
     * Get ProjectID value
     * @return int
     */
    public function getProjectID()
    {
        return $this->ProjectID;
    }
    /**
     * Set ProjectID value
     * @param int $projectID
     * @return \StructType\Invoice_TypeDefined
     */
    public function setProjectID($projectID = null)
    {
        // validation for constraint: int
        if (!is_null($projectID) && !(is_int($projectID) || ctype_digit($projectID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($projectID, true), gettype($projectID)), __LINE__);
        }
        $this->ProjectID = $projectID;
        return $this;
    }
    /**
     * Get ExchangeRate value
     * @return float
     */
    public function getExchangeRate()
    {
        return $this->ExchangeRate;
    }
    /**
     * Set ExchangeRate value
     * @param float $exchangeRate
     * @return \StructType\Invoice_TypeDefined
     */
    public function setExchangeRate($exchangeRate = null)
    {
        // validation for constraint: float
        if (!is_null($exchangeRate) && !(is_float($exchangeRate) || is_numeric($exchangeRate))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($exchangeRate, true), gettype($exchangeRate)), __LINE__);
        }
        $this->ExchangeRate = $exchangeRate;
        return $this;
    }
    /**
     * Get NetAmount value
     * @return float
     */
    public function getNetAmount()
    {
        return $this->NetAmount;
    }
    /**
     * Set NetAmount value
     * @param float $netAmount
     * @return \StructType\Invoice_TypeDefined
     */
    public function setNetAmount($netAmount = null)
    {
        // validation for constraint: float
        if (!is_null($netAmount) && !(is_float($netAmount) || is_numeric($netAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($netAmount, true), gettype($netAmount)), __LINE__);
        }
        $this->NetAmount = $netAmount;
        return $this;
    }
    /**
     * Get VATAmount value
     * @return float
     */
    public function getVATAmount()
    {
        return $this->VATAmount;
    }
    /**
     * Set VATAmount value
     * @param float $vATAmount
     * @return \StructType\Invoice_TypeDefined
     */
    public function setVATAmount($vATAmount = null)
    {
        // validation for constraint: float
        if (!is_null($vATAmount) && !(is_float($vATAmount) || is_numeric($vATAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($vATAmount, true), gettype($vATAmount)), __LINE__);
        }
        $this->VATAmount = $vATAmount;
        return $this;
    }
    /**
     * Get AmountPaid value
     * @return float
     */
    public function getAmountPaid()
    {
        return $this->AmountPaid;
    }
    /**
     * Set AmountPaid value
     * @param float $amountPaid
     * @return \StructType\Invoice_TypeDefined
     */
    public function setAmountPaid($amountPaid = null)
    {
        // validation for constraint: float
        if (!is_null($amountPaid) && !(is_float($amountPaid) || is_numeric($amountPaid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amountPaid, true), gettype($amountPaid)), __LINE__);
        }
        $this->AmountPaid = $amountPaid;
        return $this;
    }
    /**
     * Get Customer value
     * @return string|null
     */
    public function getCustomer()
    {
        return $this->Customer;
    }
    /**
     * Set Customer value
     * @param string $customer
     * @return \StructType\Invoice_TypeDefined
     */
    public function setCustomer($customer = null)
    {
        // validation for constraint: string
        if (!is_null($customer) && !is_string($customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customer, true), gettype($customer)), __LINE__);
        }
        $this->Customer = $customer;
        return $this;
    }
    /**
     * Get CustomerReference value
     * @return string|null
     */
    public function getCustomerReference()
    {
        return $this->CustomerReference;
    }
    /**
     * Set CustomerReference value
     * @param string $customerReference
     * @return \StructType\Invoice_TypeDefined
     */
    public function setCustomerReference($customerReference = null)
    {
        // validation for constraint: string
        if (!is_null($customerReference) && !is_string($customerReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerReference, true), gettype($customerReference)), __LINE__);
        }
        $this->CustomerReference = $customerReference;
        return $this;
    }
    /**
     * Get EstimateCategory value
     * @return string|null
     */
    public function getEstimateCategory()
    {
        return $this->EstimateCategory;
    }
    /**
     * Set EstimateCategory value
     * @param string $estimateCategory
     * @return \StructType\Invoice_TypeDefined
     */
    public function setEstimateCategory($estimateCategory = null)
    {
        // validation for constraint: string
        if (!is_null($estimateCategory) && !is_string($estimateCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estimateCategory, true), gettype($estimateCategory)), __LINE__);
        }
        $this->EstimateCategory = $estimateCategory;
        return $this;
    }
    /**
     * Get CurrencyCode value
     * @return string|null
     */
    public function getCurrencyCode()
    {
        return $this->CurrencyCode;
    }
    /**
     * Set CurrencyCode value
     * @param string $currencyCode
     * @return \StructType\Invoice_TypeDefined
     */
    public function setCurrencyCode($currencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($currencyCode) && !is_string($currencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyCode, true), gettype($currencyCode)), __LINE__);
        }
        $this->CurrencyCode = $currencyCode;
        return $this;
    }
    /**
     * Get ReadableString value
     * @return string|null
     */
    public function getReadableString()
    {
        return $this->ReadableString;
    }
    /**
     * Set ReadableString value
     * @param string $readableString
     * @return \StructType\Invoice_TypeDefined
     */
    public function setReadableString($readableString = null)
    {
        // validation for constraint: string
        if (!is_null($readableString) && !is_string($readableString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($readableString, true), gettype($readableString)), __LINE__);
        }
        $this->ReadableString = $readableString;
        return $this;
    }
    /**
     * Get Lines value
     * @return \ArrayType\ArrayOfInvoiceLine|null
     */
    public function getLines()
    {
        return $this->Lines;
    }
    /**
     * Set Lines value
     * @param \ArrayType\ArrayOfInvoiceLine $lines
     * @return \StructType\Invoice_TypeDefined
     */
    public function setLines(\ArrayType\ArrayOfInvoiceLine $lines = null)
    {
        $this->Lines = $lines;
        return $this;
    }
    /**
     * Get CustomerName value
     * @return string|null
     */
    public function getCustomerName()
    {
        return $this->CustomerName;
    }
    /**
     * Set CustomerName value
     * @param string $customerName
     * @return \StructType\Invoice_TypeDefined
     */
    public function setCustomerName($customerName = null)
    {
        // validation for constraint: string
        if (!is_null($customerName) && !is_string($customerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerName, true), gettype($customerName)), __LINE__);
        }
        $this->CustomerName = $customerName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Invoice_TypeDefined
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
